program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  StdCtrls,
  DCPcrypt2,
  DCPblockciphers,
  DCPtwofish,
  ZLib,
  Classes,
  SELicenseSDK in 'SELicenseSDK.pas',
  SESDK in 'SESDK.pas';

var
  Cipher: TDCP_twofish;         // the cipher to use
  CipherIV: array of byte;     // the initialisation vector (for chaining modes)
  strmInput, strmOutput: TFileStream;
  src, dsc: string;
  PackedStream, UnpackedStream: TMemoryStream;
  keyStr: PAnsiChar;

procedure UnpackStream(const Src: TStream; ADest: string);
var
  DecompStream: TDecompressionStream;
  NewSize: Int64;
  B: array[1..2048] of byte;
  R: Integer;
  vDest: TStream;
  inc: string;
  p: PChar;
begin
  {$I SE_PROTECT_START.inc}
  inc := '//decode by wxyz' + #13#10#13#10;
  Src.Position := 0;
  DecompStream := TDecompressionStream.Create(Src);
  vDest := TFileStream.Create(ADest, fmCreate);
  vDest.WriteBuffer(PChar(inc)^, Length(inc));
  try
    repeat
      R := DecompStream.Read(B, SizeOf(B));
      if R > 0 then
        vDest.Write(B, R);
    until R < SizeOf(B);
  finally
    vDest.Free;
  end;
    {$I SE_PROTECT_END.inc}
end;

begin
  {$I SE_PROTECT_START.inc}
  if ParamCount <> 2 then
  begin
    Writeln('Usage:' + #09 + 'xxx.exe src.script  dsc.script');
    Exit;
  end;

  keyStr := SEDecodeStringA('ghn[8\CZ*<NtW47sZBJ@rJ{F^&fzLh6q:To%\@Fqh]],!?eGQ`]^cD7nSrvmZTbe3cmWB<srtv=;pqKV"0VnYPWQEJ%Zrh:=<jQ[]HA}5onna*2`Y,;)TEsm5j!{9T12');
  src := ParamStr(1);
  dsc := ParamStr(2);
  {
  src := 'd:\in.script';
  dsc := 'd:\out.script';
  }
  strmInput := nil;
  //strmOutput := nil;

  try
    strmInput := TFileStream.Create(src, fmOpenRead);
    PackedStream := TMemoryStream.Create;
    UnpackedStream := TMemoryStream.Create;
    //strmOutput := TFileStream.Create('d:\tmp.tmp', fmCreate);
    Cipher := TDCP_twofish.Create(nil);
    SetLength(CipherIV, TDCP_blockcipher(Cipher).BlockSize div 8);
    CipherIV[0] := $6A;
    CipherIV[1] := $91;
    CipherIV[2] := $CE;
    CipherIV[3] := $6A;
    CipherIV[4] := $59;
    CipherIV[5] := $D4;
    CipherIV[6] := $F0;
    CipherIV[7] := $42;
    CipherIV[8] := $6D;
    CipherIV[9] := $AB;
    CipherIV[10] := $C0;
    CipherIV[11] := $F2;
    CipherIV[12] := $35;
    CipherIV[13] := $C2;
    CipherIV[14] := $88;
    CipherIV[15] := $69;
    Cipher.Init(keyStr^, 128, CipherIV);  // initialise the cipher

    TDCP_blockcipher(Cipher).CipherMode := cmCBC;

    strmInput.Position := 4;
    Cipher.DecryptStream(strmInput, PackedStream, strmInput.Size - strmInput.Position); // decrypt!
    UnpackStream(PackedStream, dsc);

    Cipher.Burn;

    strmInput.Free;
    //strmOutput.Free;
    //UnpackStream(dsc);
    Writeln('File decrypted');

  except
    strmInput.Free;
    //strmOutput.Free;
    Writeln('An error occurred while processing the file');
  end;
  {$I SE_PROTECT_END.inc}
end.


